model in bcev3.bug
# 1-year sample
data in ../../data/irswap4y_sample1.R
compile, nchains(1)
initialize
adapt 5000
update 5000
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_bcev3_sample1_4y_")
coda sigma, stem("sigma_bcev3_sample1_4y_")
coda gama, stem("gamma_bcev3_sample1_4y_")
coda nu, stem("nu_bcev3_sample1_4y_") 
# 4-year sample
data in ../../data/irswap4y_sample4.R
compile, nchains(1)
initialize
adapt 5000
update 5000
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_bcev3_sample4_4y_")
coda sigma, stem("sigma_bcev3_sample4_4y_")
coda gama, stem("gamma_bcev3_sample4_4y_")
coda nu, stem("nu_bcev3_sample4_4y_") 
# full sample
data in ../../data/irswap4y.R
compile, nchains(1)
initialize
adapt 5000
update 5000
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_bcev3_full_4y_")
coda sigma, stem("sigma_bcev3_full_4y_")
coda gama, stem("gamma_bcev3_full_4y_")
coda nu, stem("nu_bcev3_full_4y_") 
