model in hpev3t.bug
# 1-year sample
data in ../data/irswap10y_sample1.R
compile, nchains(1)
initialize
adapt 5000,by(100)
update 5000,by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set rlow, thin(25) 
monitor set rup, thin(25)
monitor set nu, thin(25)
monitor set gama, thin(25)
monitor set lambda, thin(25)
#monitor set deviance
update 250000,by(1000)
coda mu, stem("mu_hpev3t_sample1_10y_")
coda sigma, stem("sigma_hpev3t_sample1_10y_")
coda rlow, stem("rlow_hpev3t_sample1_10y_")
coda rup, stem("rup_hpev3t_sample1_10y_")
coda gama, stem("gamma_hpev3t_sample1_10y_")
coda nu, stem("nu_hpev3t_sample1_10y_")
coda lambda, stem("lambda_hpev3t_sample1_10y_") 
#coda deviance, stem("deviance_atanve3t_sampl1_10y_")
# 4-year sample
data in ../data/irswap10y_sample4.R
compile, nchains(1)
initialize
adapt 5000, by(100)
update 5000, by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set rlow, thin(25) 
monitor set rup, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
monitor set lambda, thin(25)
update 250000,by(1000)
coda mu, stem("mu_hpev3t_sample4_10y_")
coda sigma, stem("sigma_hpev3t_sample4_10y_")
coda rlow, stem("rlow_hpev3t_sample4_10y_")
coda rup, stem("rup_hpev3t_sample4_10y_")
coda gama, stem("gamma_hpev3t_sample4_10y_")
coda nu, stem("nu_hpev3t_sample4_10y_") 
coda lambda, stem("lambda_hpev3t_sample4_10y_") 
# full sample
data in ../data/irswap10y.R
compile, nchains(1)
initialize
adapt 5000, by(100)
update 5000, by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set rlow, thin(25) 
monitor set rup, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
monitor set lambda, thin(25)
update 250000,by(1000)
coda mu, stem("mu_hpev3t_full_10y_")
coda sigma, stem("sigma_hpev3t_full_10y_")
coda rlow, stem("rlow_hpev3t_full_10y_")
coda rup, stem("rup_hpev3t_full_10y_")
coda gama, stem("gamma_hpev3t_full_10y_")
coda nu, stem("nu_hpev3t_full_10y_") 
coda lambda, stem("lambda_hpev3t_full_10y_") 
