% process results of Bayesian Hybrid Piecewise Elasticity of Volatility model

%% results using full sample

% load saved samples of parameters
d=load('mu_hpev3t_full_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_hpev3t_full_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_hpev3t_full_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_hpev3t_full_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_hpev3t_full_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_hpev3t_full_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_hpev3t_full_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_hpev3t_full_30y_chain1.txt');
mu_sample30y=d(:,2);
NMC=size(mu_sample1y,1);

d=load('sigma_hpev3t_full_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_hpev3t_full_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_hpev3t_full_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_hpev3t_full_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_hpev3t_full_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_hpev3t_full_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_hpev3t_full_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_hpev3t_full_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('rlow_hpev3t_full_1y_chain1.txt');
rlow_sample1y=d(:,2);
d=load('rlow_hpev3t_full_2y_chain1.txt');
rlow_sample2y=d(:,2);
d=load('rlow_hpev3t_full_3y_chain1.txt');
rlow_sample3y=d(:,2);
d=load('rlow_hpev3t_full_4y_chain1.txt');
rlow_sample4y=d(:,2);
d=load('rlow_hpev3t_full_5y_chain1.txt');
rlow_sample5y=d(:,2);
d=load('rlow_hpev3t_full_7y_chain1.txt');
rlow_sample7y=d(:,2);
d=load('rlow_hpev3t_full_10y_chain1.txt');
rlow_sample10y=d(:,2);
d=load('rlow_hpev3t_full_30y_chain1.txt');
rlow_sample30y=d(:,2);

d=load('rup_hpev3t_full_1y_chain1.txt');
rup_sample1y=d(:,2);
d=load('rup_hpev3t_full_2y_chain1.txt');
rup_sample2y=d(:,2);
d=load('rup_hpev3t_full_3y_chain1.txt');
rup_sample3y=d(:,2);
d=load('rup_hpev3t_full_4y_chain1.txt');
rup_sample4y=d(:,2);
d=load('rup_hpev3t_full_5y_chain1.txt');
rup_sample5y=d(:,2);
d=load('rup_hpev3t_full_7y_chain1.txt');
rup_sample7y=d(:,2);
d=load('rup_hpev3t_full_10y_chain1.txt');
rup_sample10y=d(:,2);
d=load('rup_hpev3t_full_30y_chain1.txt');
rup_sample30y=d(:,2);

d=load('gamma_hpev3t_full_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_hpev3t_full_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_hpev3t_full_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_hpev3t_full_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_hpev3t_full_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_hpev3t_full_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_hpev3t_full_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_hpev3t_full_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_hpev3t_full_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_hpev3t_full_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_hpev3t_full_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_hpev3t_full_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_hpev3t_full_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_hpev3t_full_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_hpev3t_full_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_hpev3t_full_30y_chain1.txt');
nu_sample30y=d(:,2);

d=load('lambda_hpev3t_full_1y_chain1.txt');
lambda_sample1y=d(:,2);
d=load('lambda_hpev3t_full_2y_chain1.txt');
lambda_sample2y=d(:,2);
d=load('lambda_hpev3t_full_3y_chain1.txt');
lambda_sample3y=d(:,2);
d=load('lambda_hpev3t_full_4y_chain1.txt');
lambda_sample4y=d(:,2);
d=load('lambda_hpev3t_full_5y_chain1.txt');
lambda_sample5y=d(:,2);
d=load('lambda_hpev3t_full_7y_chain1.txt');
lambda_sample7y=d(:,2);
d=load('lambda_hpev3t_full_10y_chain1.txt');
lambda_sample10y=d(:,2);
d=load('lambda_hpev3t_full_30y_chain1.txt');
lambda_sample30y=d(:,2);


% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_rlow=mean([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);
median_rlow=median([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);
p025_rlow=prctile([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y],2.5);
p975_rlow=prctile([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y],97.5);
std_rlow=std([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);

mean_rup=mean([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);
median_rup=median([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);
p025_rup=prctile([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y],2.5);
p975_rup=prctile([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y],97.5);
std_rup=std([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_lambda=mean([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);
median_lambda=median([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);
p025_lambda=prctile([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y],2.5);
p975_lambda=prctile([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y],97.5);
std_lambda=std([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_rlow;median_rup;median_gamma;median_lambda;median_nu];
p025=[p025_mu;p025_sigma;p025_rlow;p025_rup;p025_gamma;p025_lambda;p025_nu];
p975=[p975_mu;p975_sigma;p975_rlow;p975_rup;p975_gamma;p975_lambda;p975_nu];
swap_maturity={'1y','2y','3y','4y','5y','7y','10y','30y'};
pname={'mu','sigma','rlow','rup','gamma','lambda','nu'};
NM=8;
NV=7;

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_hpev3t_full_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

% kernel-smoothed density plots of posterior marginal densities
NK=100;
samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,rlow_sample1y,rup_sample1y,gamma_sample1y,lambda_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,rlow_sample2y,rup_sample2y,gamma_sample2y,lambda_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,rlow_sample3y,rup_sample3y,gamma_sample3y,lambda_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,rlow_sample4y,rup_sample4y,gamma_sample4y,lambda_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,rlow_sample5y,rup_sample5y,gamma_sample5y,lambda_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,rlow_sample7y,rup_sample7y,gamma_sample7y,lambda_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,rlow_sample10y,rup_sample10y,gamma_sample10y,lambda_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,rlow_sample30y,rup_sample30y,gamma_sample30y,lambda_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

% all maturity-dependent densities
for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<5
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<6
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.1,2.1]);
        elseif j<7
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,130]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},'US Interest Rate Swaps (full sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_full_ksd_hpev3t'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_hpev3t_fullsample_postprocess.mat

%% 4-year subsample
% load saved samples of parameters
d=load('mu_hpev3t_sample4_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_hpev3t_sample4_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_hpev3t_sample4_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_hpev3t_sample4_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_hpev3t_sample4_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_hpev3t_sample4_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_hpev3t_sample4_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_hpev3t_sample4_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_hpev3t_sample4_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_hpev3t_sample4_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_hpev3t_sample4_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_hpev3t_sample4_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_hpev3t_sample4_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_hpev3t_sample4_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_hpev3t_sample4_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_hpev3t_sample4_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('rlow_hpev3t_sample4_1y_chain1.txt');
rlow_sample1y=d(:,2);
d=load('rlow_hpev3t_sample4_2y_chain1.txt');
rlow_sample2y=d(:,2);
d=load('rlow_hpev3t_sample4_3y_chain1.txt');
rlow_sample3y=d(:,2);
d=load('rlow_hpev3t_sample4_4y_chain1.txt');
rlow_sample4y=d(:,2);
d=load('rlow_hpev3t_sample4_5y_chain1.txt');
rlow_sample5y=d(:,2);
d=load('rlow_hpev3t_sample4_7y_chain1.txt');
rlow_sample7y=d(:,2);
d=load('rlow_hpev3t_sample4_10y_chain1.txt');
rlow_sample10y=d(:,2);
d=load('rlow_hpev3t_sample4_30y_chain1.txt');
rlow_sample30y=d(:,2);

d=load('rup_hpev3t_sample4_1y_chain1.txt');
rup_sample1y=d(:,2);
d=load('rup_hpev3t_sample4_2y_chain1.txt');
rup_sample2y=d(:,2);
d=load('rup_hpev3t_sample4_3y_chain1.txt');
rup_sample3y=d(:,2);
d=load('rup_hpev3t_sample4_4y_chain1.txt');
rup_sample4y=d(:,2);
d=load('rup_hpev3t_sample4_5y_chain1.txt');
rup_sample5y=d(:,2);
d=load('rup_hpev3t_sample4_7y_chain1.txt');
rup_sample7y=d(:,2);
d=load('rup_hpev3t_sample4_10y_chain1.txt');
rup_sample10y=d(:,2);
d=load('rup_hpev3t_sample4_30y_chain1.txt');
rup_sample30y=d(:,2);

d=load('gamma_hpev3t_sample4_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_hpev3t_sample4_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_hpev3t_sample4_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_hpev3t_sample4_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_hpev3t_sample4_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_hpev3t_sample4_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_hpev3t_sample4_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_hpev3t_sample4_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_hpev3t_sample4_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_hpev3t_sample4_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_hpev3t_sample4_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_hpev3t_sample4_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_hpev3t_sample4_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_hpev3t_sample4_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_hpev3t_sample4_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_hpev3t_sample4_30y_chain1.txt');
nu_sample30y=d(:,2);

d=load('lambda_hpev3t_sample4_1y_chain1.txt');
lambda_sample1y=d(:,2);
d=load('lambda_hpev3t_sample4_2y_chain1.txt');
lambda_sample2y=d(:,2);
d=load('lambda_hpev3t_sample4_3y_chain1.txt');
lambda_sample3y=d(:,2);
d=load('lambda_hpev3t_sample4_4y_chain1.txt');
lambda_sample4y=d(:,2);
d=load('lambda_hpev3t_sample4_5y_chain1.txt');
lambda_sample5y=d(:,2);
d=load('lambda_hpev3t_sample4_7y_chain1.txt');
lambda_sample7y=d(:,2);
d=load('lambda_hpev3t_sample4_10y_chain1.txt');
lambda_sample10y=d(:,2);
d=load('lambda_hpev3t_sample4_30y_chain1.txt');
lambda_sample30y=d(:,2);

% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_rlow=mean([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);
median_rlow=median([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);
p025_rlow=prctile([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y],2.5);
p975_rlow=prctile([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y],97.5);
std_rlow=std([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);

mean_rup=mean([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);
median_rup=median([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);
p025_rup=prctile([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y],2.5);
p975_rup=prctile([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y],97.5);
std_rup=std([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_lambda=mean([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);
median_lambda=median([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);
p025_lambda=prctile([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y],2.5);
p975_lambda=prctile([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y],97.5);
std_lambda=std([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_rlow;median_rup;median_gamma;median_lambda;median_nu];
p025=[p025_mu;p025_sigma;p025_rlow;p025_rup;p025_gamma;p025_lambda;p025_nu];
p975=[p975_mu;p975_sigma;p975_rlow;p975_rup;p975_gamma;p975_lambda;p975_nu];

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_hpev3t_sample4_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,rlow_sample1y,rup_sample1y,gamma_sample1y,lambda_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,rlow_sample2y,rup_sample2y,gamma_sample2y,lambda_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,rlow_sample3y,rup_sample3y,gamma_sample3y,lambda_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,rlow_sample4y,rup_sample4y,gamma_sample4y,lambda_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,rlow_sample5y,rup_sample5y,gamma_sample5y,lambda_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,rlow_sample7y,rup_sample7y,gamma_sample7y,lambda_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,rlow_sample10y,rup_sample10y,gamma_sample10y,lambda_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,rlow_sample30y,rup_sample30y,gamma_sample30y,lambda_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

% all maturity-dependent densities
for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<5
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<6
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.1,2.1]);
        elseif j<7
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,130]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (4-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample4_ksd_hpev3t'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_hpev3t_sample4_postprocess.mat

%% 1-year subsample
% load saved samples of parameters
d=load('mu_hpev3t_sample1_1y_chain1.txt');
mu_sample1y=d(:,2);
d=load('mu_hpev3t_sample1_2y_chain1.txt');
mu_sample2y=d(:,2);
d=load('mu_hpev3t_sample1_3y_chain1.txt');
mu_sample3y=d(:,2);
d=load('mu_hpev3t_sample1_4y_chain1.txt');
mu_sample4y=d(:,2);
d=load('mu_hpev3t_sample1_5y_chain1.txt');
mu_sample5y=d(:,2);
d=load('mu_hpev3t_sample1_7y_chain1.txt');
mu_sample7y=d(:,2);
d=load('mu_hpev3t_sample1_10y_chain1.txt');
mu_sample10y=d(:,2);
d=load('mu_hpev3t_sample1_30y_chain1.txt');
mu_sample30y=d(:,2);

d=load('sigma_hpev3t_sample1_1y_chain1.txt');
sigma_sample1y=d(:,2);
d=load('sigma_hpev3t_sample1_2y_chain1.txt');
sigma_sample2y=d(:,2);
d=load('sigma_hpev3t_sample1_3y_chain1.txt');
sigma_sample3y=d(:,2);
d=load('sigma_hpev3t_sample1_4y_chain1.txt');
sigma_sample4y=d(:,2);
d=load('sigma_hpev3t_sample1_5y_chain1.txt');
sigma_sample5y=d(:,2);
d=load('sigma_hpev3t_sample1_7y_chain1.txt');
sigma_sample7y=d(:,2);
d=load('sigma_hpev3t_sample1_10y_chain1.txt');
sigma_sample10y=d(:,2);
d=load('sigma_hpev3t_sample1_30y_chain1.txt');
sigma_sample30y=d(:,2);

d=load('rlow_hpev3t_sample1_1y_chain1.txt');
rlow_sample1y=d(:,2);
d=load('rlow_hpev3t_sample1_2y_chain1.txt');
rlow_sample2y=d(:,2);
d=load('rlow_hpev3t_sample1_3y_chain1.txt');
rlow_sample3y=d(:,2);
d=load('rlow_hpev3t_sample1_4y_chain1.txt');
rlow_sample4y=d(:,2);
d=load('rlow_hpev3t_sample1_5y_chain1.txt');
rlow_sample5y=d(:,2);
d=load('rlow_hpev3t_sample1_7y_chain1.txt');
rlow_sample7y=d(:,2);
d=load('rlow_hpev3t_sample1_10y_chain1.txt');
rlow_sample10y=d(:,2);
d=load('rlow_hpev3t_sample1_30y_chain1.txt');
rlow_sample30y=d(:,2);

d=load('rup_hpev3t_sample1_1y_chain1.txt');
rup_sample1y=d(:,2);
d=load('rup_hpev3t_sample1_2y_chain1.txt');
rup_sample2y=d(:,2);
d=load('rup_hpev3t_sample1_3y_chain1.txt');
rup_sample3y=d(:,2);
d=load('rup_hpev3t_sample1_4y_chain1.txt');
rup_sample4y=d(:,2);
d=load('rup_hpev3t_sample1_5y_chain1.txt');
rup_sample5y=d(:,2);
d=load('rup_hpev3t_sample1_7y_chain1.txt');
rup_sample7y=d(:,2);
d=load('rup_hpev3t_sample1_10y_chain1.txt');
rup_sample10y=d(:,2);
d=load('rup_hpev3t_sample1_30y_chain1.txt');
rup_sample30y=d(:,2);

d=load('gamma_hpev3t_sample1_1y_chain1.txt');
gamma_sample1y=d(:,2);
d=load('gamma_hpev3t_sample1_2y_chain1.txt');
gamma_sample2y=d(:,2);
d=load('gamma_hpev3t_sample1_3y_chain1.txt');
gamma_sample3y=d(:,2);
d=load('gamma_hpev3t_sample1_4y_chain1.txt');
gamma_sample4y=d(:,2);
d=load('gamma_hpev3t_sample1_5y_chain1.txt');
gamma_sample5y=d(:,2);
d=load('gamma_hpev3t_sample1_7y_chain1.txt');
gamma_sample7y=d(:,2);
d=load('gamma_hpev3t_sample1_10y_chain1.txt');
gamma_sample10y=d(:,2);
d=load('gamma_hpev3t_sample1_30y_chain1.txt');
gamma_sample30y=d(:,2);

d=load('nu_hpev3t_sample1_1y_chain1.txt');
nu_sample1y=d(:,2);
d=load('nu_hpev3t_sample1_2y_chain1.txt');
nu_sample2y=d(:,2);
d=load('nu_hpev3t_sample1_3y_chain1.txt');
nu_sample3y=d(:,2);
d=load('nu_hpev3t_sample1_4y_chain1.txt');
nu_sample4y=d(:,2);
d=load('nu_hpev3t_sample1_5y_chain1.txt');
nu_sample5y=d(:,2);
d=load('nu_hpev3t_sample1_7y_chain1.txt');
nu_sample7y=d(:,2);
d=load('nu_hpev3t_sample1_10y_chain1.txt');
nu_sample10y=d(:,2);
d=load('nu_hpev3t_sample1_30y_chain1.txt');
nu_sample30y=d(:,2);

d=load('lambda_hpev3t_sample1_1y_chain1.txt');
lambda_sample1y=d(:,2);
d=load('lambda_hpev3t_sample1_2y_chain1.txt');
lambda_sample2y=d(:,2);
d=load('lambda_hpev3t_sample1_3y_chain1.txt');
lambda_sample3y=d(:,2);
d=load('lambda_hpev3t_sample1_4y_chain1.txt');
lambda_sample4y=d(:,2);
d=load('lambda_hpev3t_sample1_5y_chain1.txt');
lambda_sample5y=d(:,2);
d=load('lambda_hpev3t_sample1_7y_chain1.txt');
lambda_sample7y=d(:,2);
d=load('lambda_hpev3t_sample1_10y_chain1.txt');
lambda_sample10y=d(:,2);
d=load('lambda_hpev3t_sample1_30y_chain1.txt');
lambda_sample30y=d(:,2);

% compute some simple statistics
mean_mu=mean([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
median_mu=median([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);
p025_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],2.5);
p975_mu=prctile([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y],97.5);
std_mu=std([mu_sample1y,mu_sample2y,mu_sample3y,mu_sample4y,...
    mu_sample5y,mu_sample7y,mu_sample10y,mu_sample30y]);

mean_sigma=mean([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
median_sigma=median([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);
p025_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],2.5);
p975_sigma=prctile([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y],97.5);
std_sigma=std([sigma_sample1y,sigma_sample2y,sigma_sample3y,sigma_sample4y,...
    sigma_sample5y,sigma_sample7y,sigma_sample10y,sigma_sample30y]);

mean_rlow=mean([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);
median_rlow=median([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);
p025_rlow=prctile([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y],2.5);
p975_rlow=prctile([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y],97.5);
std_rlow=std([rlow_sample1y,rlow_sample2y,rlow_sample3y,rlow_sample4y,...
    rlow_sample5y,rlow_sample7y,rlow_sample10y,rlow_sample30y]);

mean_rup=mean([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);
median_rup=median([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);
p025_rup=prctile([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y],2.5);
p975_rup=prctile([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y],97.5);
std_rup=std([rup_sample1y,rup_sample2y,rup_sample3y,rup_sample4y,...
    rup_sample5y,rup_sample7y,rup_sample10y,rup_sample30y]);

mean_gamma=mean([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
median_gamma=median([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);
p025_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],2.5);
p975_gamma=prctile([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y],97.5);
std_gamma=std([gamma_sample1y,gamma_sample2y,gamma_sample3y,gamma_sample4y,...
    gamma_sample5y,gamma_sample7y,gamma_sample10y,gamma_sample30y]);

mean_lambda=mean([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);
median_lambda=median([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);
p025_lambda=prctile([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y],2.5);
p975_lambda=prctile([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y],97.5);
std_lambda=std([lambda_sample1y,lambda_sample2y,lambda_sample3y,lambda_sample4y,...
    lambda_sample5y,lambda_sample7y,lambda_sample10y,lambda_sample30y]);

mean_nu=mean([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
median_nu=median([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);
p025_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],2.5);
p975_nu=prctile([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y],97.5);
std_nu=std([nu_sample1y,nu_sample2y,nu_sample3y,nu_sample4y,...
    nu_sample5y,nu_sample7y,nu_sample10y,nu_sample30y]);

medians=[median_mu;median_sigma;median_rlow;median_rup;median_gamma;median_lambda;median_nu];
p025=[p025_mu;p025_sigma;p025_rlow;p025_rup;p025_gamma;p025_lambda;p025_nu];
p975=[p975_mu;p975_sigma;p975_rlow;p975_rup;p975_gamma;p975_lambda;p975_nu];

% save posterior medians and posterior 95% confidence intervals into a file
fid=fopen('irswap_hpev3t_sample1_stats.csv','w');
fprintf(fid,'%s,%s,%s,%s,%s\n','Swap Maturity','Parameter','Posterior Median',...
    'Posterior 2.5th percentile','Posterior 97.5th percentile');
for i=1:NM
    for j=1:NV
        fprintf(fid,'%s,%s,%7.4f,%7.4f,%7.4f\n',swap_maturity{i},pname{j},...
            medians(j,i),p025(j,i),p975(j,i));
    end
end
fclose(fid);

samples=NaN(NMC,NV,NM);
samples(:,:,1)=[mu_sample1y,sigma_sample1y,rlow_sample1y,rup_sample1y,gamma_sample1y,lambda_sample1y,nu_sample1y];
samples(:,:,2)=[mu_sample2y,sigma_sample2y,rlow_sample2y,rup_sample2y,gamma_sample2y,lambda_sample2y,nu_sample2y];
samples(:,:,3)=[mu_sample3y,sigma_sample3y,rlow_sample3y,rup_sample3y,gamma_sample3y,lambda_sample3y,nu_sample3y];
samples(:,:,4)=[mu_sample4y,sigma_sample4y,rlow_sample4y,rup_sample4y,gamma_sample4y,lambda_sample4y,nu_sample4y];
samples(:,:,5)=[mu_sample5y,sigma_sample5y,rlow_sample5y,rup_sample5y,gamma_sample5y,lambda_sample5y,nu_sample5y];
samples(:,:,6)=[mu_sample7y,sigma_sample7y,rlow_sample7y,rup_sample7y,gamma_sample7y,lambda_sample7y,nu_sample7y];
samples(:,:,7)=[mu_sample10y,sigma_sample10y,rlow_sample10y,rup_sample10y,gamma_sample10y,lambda_sample10y,nu_sample10y];
samples(:,:,8)=[mu_sample30y,sigma_sample30y,rlow_sample30y,rup_sample30y,gamma_sample30y,lambda_sample30y,nu_sample30y];

ksd=NaN(NV,NK,NM);
xsd=NaN(NV,NK,NM);

% all maturity-dependent densities
for i=1:NM
    for j=1:NV
        lb=prctile(samples(:,j,i),2.5);
        ub=prctile(samples(:,j,i),97.5);
        il=find(samples(:,j,i)>lb);
        gsample=samples(il,j,i);
        iu=find(gsample<ub);
        fsample=gsample(iu);
        if j<2
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        elseif j<5
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','positive');
        elseif j<6
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[-1.1,2.1]);
        elseif j<7
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support','unbounded');
        else
            [ksd(j,:,i),xsd(j,:,i)]=ksdensity(fsample,'npoints',NK,'support',[2,130]);
        end
        figure;
        plot(xsd(j,:,i),ksd(j,:,i),'r-','LineWidth',2);
        xlabel(pname{j});
        ylabel('Marginal Posterior Density');
        title([swap_maturity{i},' US Interest Rate Swaps (1-year sample)']);
        filename=[pname{j},'_',swap_maturity{i},'_sample1_ksd_hpev3t'];
        print('-depsc2',[filename,'.eps']);
        print('-djpeg',[filename,'.jpg']);
        print('-dpdf',[filename,'.pdf']);
    end
end

% save data to mat file
save irswap_hpev3t_sample1_postprocess.mat