model in atanvev3_t.bug
# 1-year sample
data in ../data/irswap10y_sample1.R
compile, nchains(1)
initialize
adapt 5000,by(100)
update 5000,by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set beta1, thin(25) 
monitor set beta2, thin(25)
monitor set nu, thin(25)
monitor set gama, thin(25)
#monitor set deviance
update 250000,by(1000)
coda mu, stem("mu_atanvev3t_sample1_10y_")
coda sigma, stem("sigma_atanvev3t_sample1_10y_")
coda beta1, stem("beta1_atanvev3t_sample1_10y_")
coda beta2, stem("beta2_atanvev3t_sample1_10y_")
coda gama, stem("gamma_atanvev3t_sample1_10y_")
coda nu, stem("nu_atanvev3t_sample1_10y_") 
#coda deviance, stem("deviance_atanve3t_sampl1_10y_")
# 4-year sample
data in ../data/irswap10y_sample4.R
compile, nchains(1)
initialize
adapt 5000, by(100)
update 5000, by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set beta1, thin(25) 
monitor set beta2, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_atanvev3t_sample4_10y_")
coda sigma, stem("sigma_atanvev3t_sample4_10y_")
coda beta1, stem("beta1_atanvev3t_sample4_10y_")
coda beta2, stem("beta2_atanvev3t_sample4_10y_")
coda gama, stem("gamma_atanvev3t_sample4_10y_")
coda nu, stem("nu_atanvev3t_sample4_10y_") 
# full sample
data in ../data/irswap10y.R
compile, nchains(1)
initialize
adapt 5000, by(100)
update 5000, by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set beta1, thin(25) 
monitor set beta2, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_atanvev3t_full_10y_")
coda sigma, stem("sigma_atanvev3t_full_10y_")
coda beta1, stem("beta1_atanvev3t_full_10y_")
coda beta2, stem("beta2_atanvev3t_full_10y_")
coda gama, stem("gamma_atanvev3t_full_10y_")
coda nu, stem("nu_atanvev3t_full_10y_") 
