model in vevtsq.bug
# full sample
data in ../data/irswap2y.R
compile, nchains(1)
initialize
adapt 5000,by(100)
update 5000,by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set beta0, thin(25) 
monitor set beta1, thin(25) 
monitor set beta2, thin(25)
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_vevtsq_full_2y_")
coda sigma, stem("sigma_vevtsq_full_2y_")
coda beta0, stem("beta0_vevtsq_full_2y_")
coda beta1, stem("beta1_vevtsq_full_2y_")
coda beta2, stem("beta2_vevtsq_full_2y_")
coda nu, stem("nu_vevtsq_full_2y_") 
# 1-year sample
data in ../data/irswap2y_sample1.R
compile, nchains(1)
initialize
adapt 5000,by(100)
update 5000,by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set beta0, thin(25) 
monitor set beta1, thin(25) 
monitor set beta2, thin(25)
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_vevtsq_sample1_2y_")
coda sigma, stem("sigma_vevtsq_sample1_2y_")
coda beta0, stem("beta0_vevtsq_sample1_2y_")
coda beta1, stem("beta1_vevtsq_sample1_2y_")
coda beta2, stem("beta2_vevtsq_sample1_2y_")
coda nu, stem("nu_vevtsq_sample1_2y_") 
# 4-year sample
data in ../data/irswap2y_sample4.R
compile, nchains(1)
initialize
adapt 5000,by(100)
update 5000,by(100)
monitor set mu, thin(25)
monitor set sigma, thin(25)
monitor set beta0, thin(25) 
monitor set beta1, thin(25) 
monitor set beta2, thin(25)
monitor set nu, thin(25)
update 250000,by(1000)
coda mu, stem("mu_vevtsq_sample4_2y_")
coda sigma, stem("sigma_vevtsq_sample4_2y_")
coda beta0, stem("beta0_vevtsq_sample4_2y_")
coda beta1, stem("beta1_vevtsq_sample4_2y_")
coda beta2, stem("beta2_vevtsq_sample4_2y_")
coda nu, stem("nu_vevtsq_sample4_2y_") 
