model in bcev4.bug
# swaps with 1y maturity
data in ../../data/irswap1y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_1y_")
coda rho, stem("rho_full_1y_")
coda sigma, stem("sigma_full_1y_")
coda gama, stem("gamma_full_1y_")
coda nu, stem("nu_full_1y_") 
# swaps with 2y maturity
data in ../../data/irswap2y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_2y_")
coda rho, stem("rho_full_2y_")
coda sigma, stem("sigma_full_2y_")
coda gama, stem("gamma_full_2y_")
coda nu, stem("nu_full_2y_")
# swaps with 3y maturity
data in ../../data/irswap3y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_3y_")
coda rho, stem("rho_full_3y_")
coda sigma, stem("sigma_full_3y_")
coda gama, stem("gamma_full_3y_")
coda nu, stem("nu_full_3y_")
# swaps with 4y maturity
data in ../../data/irswap4y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_4y_")
coda rho, stem("rho_full_4y_")
coda sigma, stem("sigma_full_4y_")
coda gama, stem("gamma_full_4y_")
coda nu, stem("nu_full_4y_")
# swaps with 5y maturity
data in ../../data/irswap5y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_5y_")
coda rho, stem("rho_full_5y_")
coda sigma, stem("sigma_full_5y_")
coda gama, stem("gamma_full_5y_")
coda nu, stem("nu_full_5y_")
# swaps with 7y maturity
data in ../../data/irswap7y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_7y_")
coda rho, stem("rho_full_7y_")
coda sigma, stem("sigma_full_7y_")
coda gama, stem("gamma_full_7y_")
coda nu, stem("nu_full_7y_")
# swaps with 10y maturity
data in ../../data/irswap10y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_10y_")
coda rho, stem("rho_full_10y_")
coda sigma, stem("sigma_full_10y_")
coda gama, stem("gamma_full_10y_")
coda nu, stem("nu_full_10y_")
# swaps with 30y maturity
data in ../../data/irswap30y.R
compile
initialize
# ARMS adaptation
adapt 5000
# burn-in
update 5000
# set monitors
monitor set mu, thin(25)
monitor set rho, thin(25)
monitor set sigma, thin(25)
monitor set gama, thin(25) 
monitor set nu, thin(25)
update 250000,by(1000)
coda mu,stem("mu_full_30y_")
coda rho, stem("rho_full_30y_")
coda sigma, stem("sigma_full_30y_")
coda gama, stem("gamma_full_30y_")
coda nu, stem("nu_full_30y_")
