% testing cevt_nyblom function under null

T=3019;
r0=2.9;
sigma=0.02;
mu=0.01;
gamma=0.75;
nu=6;
r = cev3_t_simulator(T,mu,sigma,gamma,nu,r0);
nyb=cevt_nyblom(r,mu,sigma,gamma,nu);

NMC=1000000;
nybs=NaN(NMC,1);
h=waitbar(0,'Simulating Nyblom tests under null');
for i=1:NMC
    r(1)=-1;
    waitbar(i/NMC);
    while min(r)<0
        r = cev3_t_simulator(T,mu,sigma,gamma,nu,r0);
    end
    nybs(i)=cevt_nyblom(r,mu,sigma,gamma,nu);
end;
close(h);

save test_cevt_nyblom_null.mat

figure;
hist(nybs,100);


    
