% testing ks_t_test function
% goodness-of-fit  tests

% load data
data=csvread('../data/irswap_daily_20000703_20120726.csv',1,1);
[T,N]=size(data);
dates=csvread('../data/irswap_daily_20000703_20120726.csv',1,0,[1,0,T,0]);
% last 4 years
i4=find(dates>=dates(end)-40000);
data4=data(i4,:);
T4=size(data4,1);
% last 1 year
i1=find(dates>=dates(end)-10000);
data1=data(i1,:);
T1=size(data1,1);

sample=data(:,1);
df=5;
alpha=0.001;
[h,test,pval,crv0,crv1] = ks_t_test(sample,df,alpha);
disp(['Corrected Kolmogorov-Smirnov-Lilliefors test statistics:   ',num2str(test,'%8.6g')]);
disp(['p-value:                                                   ',num2str(pval,'%8.6g')]);
disp(['0.99 critical value:                                       ',num2str(crv1,'%8.6g')]);